//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "SelCMain.h"
//---------------------------------------------------------------------------
#pragma link "TrayIcon"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
	GetCurrentConnect();
    GetConnectAddresses();
    int index = ConnectAddresses->IndexOf(CurrentConnect);
    MakeMenu(ConnectAddresses->Count, index);
    TrayIcon1->Hint = CurrentConnect;
    Application->Minimize();

}
//---------------------------------------------------------------------------
void __fastcall TForm1::TrayIcon1Click(TObject *Sender)
{
 	TPoint *CursorPos = new TPoint;

    GetCursorPos(CursorPos);
	PopupMenu1->Popup(CursorPos->x,CursorPos->x);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Exit1Click(TObject *Sender)
{
	Form1->Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::GetCurrentConnect(void)
{
 	TRegistry& Reg = *new TRegistry();
    Reg.RootKey = HKEY_CURRENT_USER;
    String KeyStr ="\\RemoteAccess";
    bool KeyExist = Reg.OpenKey(KeyStr, false);
    if (KeyExist){
		CurrentConnect = Reg.ReadString("InternetProfile");
    }
    delete &Reg;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::GetConnectAddresses(void)
{
	ConnectAddresses = new TStringList;
 	TRegistry& Reg = *new TRegistry();
    String KeyStr ="\\RemoteAccess\\Addresses";
    bool KeyExist = Reg.OpenKey(KeyStr, false);
    if (KeyExist){
		Reg.GetValueNames(ConnectAddresses);
    }
    delete &Reg;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
	delete ConnectAddresses;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MakeMenu(int items, int index)
{
	for (int i = items-1; i >= 0; i--){
 	    TMenuItem *NewItem = new TMenuItem((TComponent *)PopupMenu1);
    	NewItem->Caption = ConnectAddresses->Strings[i];
		NewItem->OnClick = MenuItemClick;
    	PopupMenu1->Items->Insert(0, NewItem);
    }
    PopupMenu1->Items->Items[index]->Checked = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MenuItemClick(TObject *Sender)
{
	String Checked = dynamic_cast<TMenuItem *>(Sender)->Caption;
    if (Checked != CurrentConnect){
        int index = ConnectAddresses->IndexOf(CurrentConnect);
        // `FbN}[N̕tւ
        PopupMenu1->Items->Items[index]->Checked = false;
		dynamic_cast<TMenuItem *>(Sender)->Checked = true;
        SetCurrentConnect(Checked);
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SetCurrentConnect(String Address)
{
	TRegistry& Reg = *new TRegistry();
   	Reg.RootKey = HKEY_CURRENT_USER;
    String KeyStr ="\\RemoteAccess";
    bool KeyExist = Reg.OpenKey(KeyStr, false);
    if (KeyExist){
		Reg.WriteString("InternetProfile", Address);
    }
   	delete &Reg;
    CurrentConnect = Address;
    TrayIcon1->Hint = Address;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AboutSelectConnection1Click(TObject *Sender)
{
	TAboutBox *AboutBox = new TAboutBox(this);
    AboutBox->ShowModal();
    delete AboutBox;	
}
//---------------------------------------------------------------------------
